package com.gic.haoban.manage.web.controller;

import java.io.IOException;
import java.util.List;

import javax.servlet.http.HttpServletResponse;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

import com.gic.commons.util.GlobalVar;
import com.gic.haoban.base.api.common.BasePageInfo;
import com.gic.haoban.common.utils.HaobanResponse;
import com.gic.haoban.manage.api.dto.YwWxEnterpriseDTO;
import com.gic.haoban.manage.api.service.WxEnterpriseApiService;
import com.gic.haoban.manage.web.errCode.HaoBanErrCode;

@RestController
public class EnterpriseController extends WebBaseController{
    private static final String LOGIN_URL = "/haoban-manage3-web/yw-login";
	private static Logger logger  = LoggerFactory.getLogger(EnterpriseController.class);

	@Autowired
	private WxEnterpriseApiService wxEnterpriseApiService;
	//企业列表
	@RequestMapping("wx-enterprise-list")
	public HaobanResponse wxEnterpriseList(BasePageInfo pageInfo,String keyword,String gicContactFlag,String version) {
		List<YwWxEnterpriseDTO> list = wxEnterpriseApiService.list(pageInfo,keyword,gicContactFlag,version);
		return resultResponse(HaoBanErrCode.ERR_1, list);
 
	}
	//登录
	@RequestMapping("yw-login")
	public void ywLogin(String wxEnterpriseId,HttpServletResponse httpServletResponse) throws IOException {
        String host = GlobalVar.ctxPropertiesMap.get("haoban_service_host");
        logger.info("host============================>{}",host);
        String url=host+LOGIN_URL+"?wxEnterpriseId="+wxEnterpriseId;
        httpServletResponse.sendRedirect(url);
	}
}
