package com.gic.haoban.manage.service.service.out.impl;

import java.util.Date;
import java.util.List;

import org.apache.logging.log4j.LogManager;
import org.apache.logging.log4j.Logger;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import com.gic.commons.util.EntityUtil;
import com.gic.enterprise.api.dto.GicTreeDTO;
import com.gic.enterprise.api.service.StoreGroupService;
import com.gic.haoban.common.utils.UuidUtil;
import com.gic.haoban.manage.api.dto.EnterpriseDetailDTO;
import com.gic.haoban.manage.api.service.WxEnterpriseRelatedApiService;
import com.gic.haoban.manage.service.dao.mapper.WxEnterpriseRelatedMapper;
import com.gic.haoban.manage.service.entity.TabHaobanWxEnterpriseRelated;
import com.gic.haoban.manage.service.service.DepartmentService;
import com.gic.haoban.manage.service.service.WxEnterpriseRelatedService;

@Service
public class WxEnterpriseRelatedApiServiceImpl implements WxEnterpriseRelatedApiService {
    private static final Logger logger = LogManager.getLogger(WxEnterpriseRelatedApiServiceImpl.class);
    @Autowired
	private WxEnterpriseRelatedMapper wxEnterpriseRelatedMapper;
	@Autowired
	private WxEnterpriseRelatedService wxEnterpriseRelatedService;
	
	@Autowired
	private StoreGroupService storeGroupService;
	@Autowired
	private DepartmentService departmentService;
	@Override
	public List<EnterpriseDetailDTO> listEnterpriseByWxEnterpriseId(
			String wxEnterpriseId) {
		
		List<TabHaobanWxEnterpriseRelated> relatedList = wxEnterpriseRelatedMapper.listByWxenterpriseId(wxEnterpriseId);
		List<EnterpriseDetailDTO> result = EntityUtil.changeEntityListByJSON(EnterpriseDetailDTO.class, relatedList);
		for (EnterpriseDetailDTO enterpriseDetailDTO : result) {
			String enterpriseId = enterpriseDetailDTO.getEnterpriseId();
			int nodeCount = 0;
			List<GicTreeDTO> departmentList = storeGroupService.listGicTree(enterpriseId,1, null);
			for (GicTreeDTO gicTreeDTO : departmentList) {
				if(departmentService.getByRelatedId(gicTreeDTO.getId()) == null) {
					nodeCount ++;
				}
				nodeCount += getNodeCount(enterpriseId,gicTreeDTO.getId(),gicTreeDTO.getType());
			}
			List<GicTreeDTO> departmentList2 = storeGroupService.listGicTree(enterpriseId,2, null);
			for (GicTreeDTO gicTreeDTO : departmentList2) {
				if(departmentService.getByRelatedId(gicTreeDTO.getId()) == null) {
					nodeCount ++;
				}
				nodeCount += getNodeCount(enterpriseId,gicTreeDTO.getId(),gicTreeDTO.getType());
			}
			enterpriseDetailDTO.setNodeCount(nodeCount);
		}
		return result;
	}
	
	public int getNodeCount(String enterpriseId,String parentId,int type) {
		int nodeCount = 0;
		List<GicTreeDTO> departmentList = storeGroupService.listGicTree(enterpriseId,type, parentId);
		for (GicTreeDTO gicTreeDTO : departmentList) {
			if(departmentService.getByRelatedId(gicTreeDTO.getId()) == null) {
				nodeCount ++;
			}
		}
		
		while(departmentList.isEmpty()) {
			for (GicTreeDTO gicTreeDTO : departmentList) {
				nodeCount += getNodeCount(enterpriseId,gicTreeDTO.getId(),gicTreeDTO.getType());
			}
		}
		return nodeCount;
		
	}
	@Override
	public int wxEnterpriseBind(String enterpriseId, String wxEnterpriseId,
			String version) {
		TabHaobanWxEnterpriseRelated tab = wxEnterpriseRelatedMapper.findOneByEnterpriseId(enterpriseId);
		if(tab!= null){
			logger.info("该gicEnterpriseId已经绑定过了");
			return 1;
		}else{
			 tab = new TabHaobanWxEnterpriseRelated();
			 tab.setEnterpriseId(enterpriseId);
			 tab.setWxEnterpriseId(wxEnterpriseId);
			 tab.setStatusFlag(1);
			 tab.setVersion(version);
			 tab.setCreateTime(new Date());
			 tab.setUpdateTime(new Date());
			 tab.setWxEnterpriseRelatedId(UuidUtil.randomUUID());
			 wxEnterpriseRelatedMapper.insertSelective(tab);
		}
		return 0;
	}
	@Override
	public String getGicEnterpriseIdByEnterpriseRelatedId(String wxEnterpriseRelatedId) {
		TabHaobanWxEnterpriseRelated tab = wxEnterpriseRelatedService.getByGicEnterpriseIdByEnterpriseRelatedId(wxEnterpriseRelatedId);
		if(tab != null) {
			return tab.getEnterpriseId();
		}
		
		return null;
	}

}
